/*
 * This file is generated by gdbus-codegen, do not modify it.
 *
 * The license of this code is the same as for the D-Bus interface description
 * it was derived from. Note that it links to GLib, so must comply with the
 * LGPL linking clauses.
 */

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

#include "panel-gdbus-exported-service.h"

#include <string.h>
#ifdef G_OS_UNIX
#  include <gio/gunixfdlist.h>
#endif

#ifdef G_ENABLE_DEBUG
#define g_marshal_value_peek_boolean(v)  g_value_get_boolean (v)
#define g_marshal_value_peek_char(v)     g_value_get_schar (v)
#define g_marshal_value_peek_uchar(v)    g_value_get_uchar (v)
#define g_marshal_value_peek_int(v)      g_value_get_int (v)
#define g_marshal_value_peek_uint(v)     g_value_get_uint (v)
#define g_marshal_value_peek_long(v)     g_value_get_long (v)
#define g_marshal_value_peek_ulong(v)    g_value_get_ulong (v)
#define g_marshal_value_peek_int64(v)    g_value_get_int64 (v)
#define g_marshal_value_peek_uint64(v)   g_value_get_uint64 (v)
#define g_marshal_value_peek_enum(v)     g_value_get_enum (v)
#define g_marshal_value_peek_flags(v)    g_value_get_flags (v)
#define g_marshal_value_peek_float(v)    g_value_get_float (v)
#define g_marshal_value_peek_double(v)   g_value_get_double (v)
#define g_marshal_value_peek_string(v)   (char*) g_value_get_string (v)
#define g_marshal_value_peek_param(v)    g_value_get_param (v)
#define g_marshal_value_peek_boxed(v)    g_value_get_boxed (v)
#define g_marshal_value_peek_pointer(v)  g_value_get_pointer (v)
#define g_marshal_value_peek_object(v)   g_value_get_object (v)
#define g_marshal_value_peek_variant(v)  g_value_get_variant (v)
#else /* !G_ENABLE_DEBUG */
/* WARNING: This code accesses GValues directly, which is UNSUPPORTED API.
 *          Do not access GValues directly in your code. Instead, use the
 *          g_value_get_*() functions
 */
#define g_marshal_value_peek_boolean(v)  (v)->data[0].v_int
#define g_marshal_value_peek_char(v)     (v)->data[0].v_int
#define g_marshal_value_peek_uchar(v)    (v)->data[0].v_uint
#define g_marshal_value_peek_int(v)      (v)->data[0].v_int
#define g_marshal_value_peek_uint(v)     (v)->data[0].v_uint
#define g_marshal_value_peek_long(v)     (v)->data[0].v_long
#define g_marshal_value_peek_ulong(v)    (v)->data[0].v_ulong
#define g_marshal_value_peek_int64(v)    (v)->data[0].v_int64
#define g_marshal_value_peek_uint64(v)   (v)->data[0].v_uint64
#define g_marshal_value_peek_enum(v)     (v)->data[0].v_long
#define g_marshal_value_peek_flags(v)    (v)->data[0].v_ulong
#define g_marshal_value_peek_float(v)    (v)->data[0].v_float
#define g_marshal_value_peek_double(v)   (v)->data[0].v_double
#define g_marshal_value_peek_string(v)   (v)->data[0].v_pointer
#define g_marshal_value_peek_param(v)    (v)->data[0].v_pointer
#define g_marshal_value_peek_boxed(v)    (v)->data[0].v_pointer
#define g_marshal_value_peek_pointer(v)  (v)->data[0].v_pointer
#define g_marshal_value_peek_object(v)   (v)->data[0].v_pointer
#define g_marshal_value_peek_variant(v)  (v)->data[0].v_pointer
#endif /* !G_ENABLE_DEBUG */

typedef struct
{
  GDBusArgInfo parent_struct;
  gboolean use_gvariant;
} _ExtendedGDBusArgInfo;

typedef struct
{
  GDBusMethodInfo parent_struct;
  const gchar *signal_name;
  gboolean pass_fdlist;
} _ExtendedGDBusMethodInfo;

typedef struct
{
  GDBusSignalInfo parent_struct;
  const gchar *signal_name;
} _ExtendedGDBusSignalInfo;

typedef struct
{
  GDBusPropertyInfo parent_struct;
  const gchar *hyphen_name;
  guint use_gvariant : 1;
  guint emits_changed_signal : 1;
} _ExtendedGDBusPropertyInfo;

typedef struct
{
  GDBusInterfaceInfo parent_struct;
  const gchar *hyphen_name;
} _ExtendedGDBusInterfaceInfo;

typedef struct
{
  const _ExtendedGDBusPropertyInfo *info;
  guint prop_id;
  GValue orig_value; /* the value before the change */
} ChangedProperty;

static void
_changed_property_free (ChangedProperty *data)
{
  g_value_unset (&data->orig_value);
  g_free (data);
}

static gboolean
_g_strv_equal0 (gchar **a, gchar **b)
{
  gboolean ret = FALSE;
  guint n;
  if (a == NULL && b == NULL)
    {
      ret = TRUE;
      goto out;
    }
  if (a == NULL || b == NULL)
    goto out;
  if (g_strv_length (a) != g_strv_length (b))
    goto out;
  for (n = 0; a[n] != NULL; n++)
    if (g_strcmp0 (a[n], b[n]) != 0)
      goto out;
  ret = TRUE;
out:
  return ret;
}

static gboolean
_g_variant_equal0 (GVariant *a, GVariant *b)
{
  gboolean ret = FALSE;
  if (a == NULL && b == NULL)
    {
      ret = TRUE;
      goto out;
    }
  if (a == NULL || b == NULL)
    goto out;
  ret = g_variant_equal (a, b);
out:
  return ret;
}

G_GNUC_UNUSED static gboolean
_g_value_equal (const GValue *a, const GValue *b)
{
  gboolean ret = FALSE;
  g_assert (G_VALUE_TYPE (a) == G_VALUE_TYPE (b));
  switch (G_VALUE_TYPE (a))
    {
      case G_TYPE_BOOLEAN:
        ret = (g_value_get_boolean (a) == g_value_get_boolean (b));
        break;
      case G_TYPE_UCHAR:
        ret = (g_value_get_uchar (a) == g_value_get_uchar (b));
        break;
      case G_TYPE_INT:
        ret = (g_value_get_int (a) == g_value_get_int (b));
        break;
      case G_TYPE_UINT:
        ret = (g_value_get_uint (a) == g_value_get_uint (b));
        break;
      case G_TYPE_INT64:
        ret = (g_value_get_int64 (a) == g_value_get_int64 (b));
        break;
      case G_TYPE_UINT64:
        ret = (g_value_get_uint64 (a) == g_value_get_uint64 (b));
        break;
      case G_TYPE_DOUBLE:
        {
          /* Avoid -Wfloat-equal warnings by doing a direct bit compare */
          gdouble da = g_value_get_double (a);
          gdouble db = g_value_get_double (b);
          ret = memcmp (&da, &db, sizeof (gdouble)) == 0;
        }
        break;
      case G_TYPE_STRING:
        ret = (g_strcmp0 (g_value_get_string (a), g_value_get_string (b)) == 0);
        break;
      case G_TYPE_VARIANT:
        ret = _g_variant_equal0 (g_value_get_variant (a), g_value_get_variant (b));
        break;
      default:
        if (G_VALUE_TYPE (a) == G_TYPE_STRV)
          ret = _g_strv_equal0 (g_value_get_boxed (a), g_value_get_boxed (b));
        else
          g_critical ("_g_value_equal() does not handle type %s", g_type_name (G_VALUE_TYPE (a)));
        break;
    }
  return ret;
}

static void
_g_dbus_codegen_marshal_BOOLEAN__OBJECT_UINT_UINT (
    GClosure     *closure,
    GValue       *return_value,
    unsigned int  n_param_values,
    const GValue *param_values,
    void         *invocation_hint G_GNUC_UNUSED,
    void         *marshal_data)
{
  typedef gboolean (*_GDbusCodegenMarshalBoolean_ObjectUintUintFunc)
       (void *data1,
        GDBusMethodInvocation *arg_method_invocation,
        guint arg_active,
        guint arg_socket_id,
        void *data2);
  _GDbusCodegenMarshalBoolean_ObjectUintUintFunc callback;
  GCClosure *cc = (GCClosure*) closure;
  void *data1, *data2;
  gboolean v_return;

  g_return_if_fail (return_value != NULL);
  g_return_if_fail (n_param_values == 4);

  if (G_CCLOSURE_SWAP_DATA (closure))
    {
      data1 = closure->data;
      data2 = g_value_peek_pointer (param_values + 0);
    }
  else
    {
      data1 = g_value_peek_pointer (param_values + 0);
      data2 = closure->data;
    }

  callback = (_GDbusCodegenMarshalBoolean_ObjectUintUintFunc)
    (marshal_data ? marshal_data : cc->callback);

  v_return =
    callback (data1,
              g_marshal_value_peek_object (param_values + 1),
              g_marshal_value_peek_uint (param_values + 2),
              g_marshal_value_peek_uint (param_values + 3),
              data2);

  g_value_set_boolean (return_value, v_return);
}

static void
_g_dbus_codegen_marshal_BOOLEAN__OBJECT_UINT (
    GClosure     *closure,
    GValue       *return_value,
    unsigned int  n_param_values,
    const GValue *param_values,
    void         *invocation_hint G_GNUC_UNUSED,
    void         *marshal_data)
{
  typedef gboolean (*_GDbusCodegenMarshalBoolean_ObjectUintFunc)
       (void *data1,
        GDBusMethodInvocation *arg_method_invocation,
        guint arg_active,
        void *data2);
  _GDbusCodegenMarshalBoolean_ObjectUintFunc callback;
  GCClosure *cc = (GCClosure*) closure;
  void *data1, *data2;
  gboolean v_return;

  g_return_if_fail (return_value != NULL);
  g_return_if_fail (n_param_values == 3);

  if (G_CCLOSURE_SWAP_DATA (closure))
    {
      data1 = closure->data;
      data2 = g_value_peek_pointer (param_values + 0);
    }
  else
    {
      data1 = g_value_peek_pointer (param_values + 0);
      data2 = closure->data;
    }

  callback = (_GDbusCodegenMarshalBoolean_ObjectUintFunc)
    (marshal_data ? marshal_data : cc->callback);

  v_return =
    callback (data1,
              g_marshal_value_peek_object (param_values + 1),
              g_marshal_value_peek_uint (param_values + 2),
              data2);

  g_value_set_boolean (return_value, v_return);
}

static void
_g_dbus_codegen_marshal_BOOLEAN__OBJECT (
    GClosure     *closure,
    GValue       *return_value,
    unsigned int  n_param_values,
    const GValue *param_values,
    void         *invocation_hint G_GNUC_UNUSED,
    void         *marshal_data)
{
  typedef gboolean (*_GDbusCodegenMarshalBoolean_ObjectFunc)
       (void *data1,
        GDBusMethodInvocation *arg_method_invocation,
        void *data2);
  _GDbusCodegenMarshalBoolean_ObjectFunc callback;
  GCClosure *cc = (GCClosure*) closure;
  void *data1, *data2;
  gboolean v_return;

  g_return_if_fail (return_value != NULL);
  g_return_if_fail (n_param_values == 2);

  if (G_CCLOSURE_SWAP_DATA (closure))
    {
      data1 = closure->data;
      data2 = g_value_peek_pointer (param_values + 0);
    }
  else
    {
      data1 = g_value_peek_pointer (param_values + 0);
      data2 = closure->data;
    }

  callback = (_GDbusCodegenMarshalBoolean_ObjectFunc)
    (marshal_data ? marshal_data : cc->callback);

  v_return =
    callback (data1,
              g_marshal_value_peek_object (param_values + 1),
              data2);

  g_value_set_boolean (return_value, v_return);
}

static void
_g_dbus_codegen_marshal_BOOLEAN__OBJECT_STRING_BOXED (
    GClosure     *closure,
    GValue       *return_value,
    unsigned int  n_param_values,
    const GValue *param_values,
    void         *invocation_hint G_GNUC_UNUSED,
    void         *marshal_data)
{
  typedef gboolean (*_GDbusCodegenMarshalBoolean_ObjectStringBoxedFunc)
       (void *data1,
        GDBusMethodInvocation *arg_method_invocation,
        const gchar *arg_plugin_name,
        const gchar *const *arg_arguments,
        void *data2);
  _GDbusCodegenMarshalBoolean_ObjectStringBoxedFunc callback;
  GCClosure *cc = (GCClosure*) closure;
  void *data1, *data2;
  gboolean v_return;

  g_return_if_fail (return_value != NULL);
  g_return_if_fail (n_param_values == 4);

  if (G_CCLOSURE_SWAP_DATA (closure))
    {
      data1 = closure->data;
      data2 = g_value_peek_pointer (param_values + 0);
    }
  else
    {
      data1 = g_value_peek_pointer (param_values + 0);
      data2 = closure->data;
    }

  callback = (_GDbusCodegenMarshalBoolean_ObjectStringBoxedFunc)
    (marshal_data ? marshal_data : cc->callback);

  v_return =
    callback (data1,
              g_marshal_value_peek_object (param_values + 1),
              g_marshal_value_peek_string (param_values + 2),
              g_marshal_value_peek_boxed (param_values + 3),
              data2);

  g_value_set_boolean (return_value, v_return);
}

static void
_g_dbus_codegen_marshal_BOOLEAN__OBJECT_STRING_STRING_VARIANT (
    GClosure     *closure,
    GValue       *return_value,
    unsigned int  n_param_values,
    const GValue *param_values,
    void         *invocation_hint G_GNUC_UNUSED,
    void         *marshal_data)
{
  typedef gboolean (*_GDbusCodegenMarshalBoolean_ObjectStringStringVariantFunc)
       (void *data1,
        GDBusMethodInvocation *arg_method_invocation,
        const gchar *arg_plugin_name,
        const gchar *arg_name,
        GVariant *arg_value,
        void *data2);
  _GDbusCodegenMarshalBoolean_ObjectStringStringVariantFunc callback;
  GCClosure *cc = (GCClosure*) closure;
  void *data1, *data2;
  gboolean v_return;

  g_return_if_fail (return_value != NULL);
  g_return_if_fail (n_param_values == 5);

  if (G_CCLOSURE_SWAP_DATA (closure))
    {
      data1 = closure->data;
      data2 = g_value_peek_pointer (param_values + 0);
    }
  else
    {
      data1 = g_value_peek_pointer (param_values + 0);
      data2 = closure->data;
    }

  callback = (_GDbusCodegenMarshalBoolean_ObjectStringStringVariantFunc)
    (marshal_data ? marshal_data : cc->callback);

  v_return =
    callback (data1,
              g_marshal_value_peek_object (param_values + 1),
              g_marshal_value_peek_string (param_values + 2),
              g_marshal_value_peek_string (param_values + 3),
              g_marshal_value_peek_variant (param_values + 4),
              data2);

  g_value_set_boolean (return_value, v_return);
}

static void
_g_dbus_codegen_marshal_BOOLEAN__OBJECT_BOOLEAN (
    GClosure     *closure,
    GValue       *return_value,
    unsigned int  n_param_values,
    const GValue *param_values,
    void         *invocation_hint G_GNUC_UNUSED,
    void         *marshal_data)
{
  typedef gboolean (*_GDbusCodegenMarshalBoolean_ObjectBooleanFunc)
       (void *data1,
        GDBusMethodInvocation *arg_method_invocation,
        gboolean arg_restart,
        void *data2);
  _GDbusCodegenMarshalBoolean_ObjectBooleanFunc callback;
  GCClosure *cc = (GCClosure*) closure;
  void *data1, *data2;
  gboolean v_return;

  g_return_if_fail (return_value != NULL);
  g_return_if_fail (n_param_values == 3);

  if (G_CCLOSURE_SWAP_DATA (closure))
    {
      data1 = closure->data;
      data2 = g_value_peek_pointer (param_values + 0);
    }
  else
    {
      data1 = g_value_peek_pointer (param_values + 0);
      data2 = closure->data;
    }

  callback = (_GDbusCodegenMarshalBoolean_ObjectBooleanFunc)
    (marshal_data ? marshal_data : cc->callback);

  v_return =
    callback (data1,
              g_marshal_value_peek_object (param_values + 1),
              g_marshal_value_peek_boolean (param_values + 2),
              data2);

  g_value_set_boolean (return_value, v_return);
}

/* ------------------------------------------------------------------------
 * Code for interface org.xfce.Panel
 * ------------------------------------------------------------------------
 */

/**
 * SECTION:XfcePanelExportedService
 * @title: XfcePanelExportedService
 * @short_description: Generated C code for the org.xfce.Panel D-Bus interface
 *
 * This section contains code for working with the <link linkend="gdbus-interface-org-xfce-Panel.top_of_page">org.xfce.Panel</link> D-Bus interface in C.
 */

/* ---- Introspection data for org.xfce.Panel ---- */

static const _ExtendedGDBusArgInfo _xfce_panel_exported_service_method_info_display_preferences_dialog_IN_ARG_active =
{
  {
    -1,
    (gchar *) "active",
    (gchar *) "u",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo _xfce_panel_exported_service_method_info_display_preferences_dialog_IN_ARG_socket_id =
{
  {
    -1,
    (gchar *) "socket_id",
    (gchar *) "u",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _xfce_panel_exported_service_method_info_display_preferences_dialog_IN_ARG_pointers[] =
{
  &_xfce_panel_exported_service_method_info_display_preferences_dialog_IN_ARG_active.parent_struct,
  &_xfce_panel_exported_service_method_info_display_preferences_dialog_IN_ARG_socket_id.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _xfce_panel_exported_service_method_info_display_preferences_dialog =
{
  {
    -1,
    (gchar *) "DisplayPreferencesDialog",
    (GDBusArgInfo **) &_xfce_panel_exported_service_method_info_display_preferences_dialog_IN_ARG_pointers,
    NULL,
    NULL
  },
  "handle-display-preferences-dialog",
  FALSE
};

static const _ExtendedGDBusArgInfo _xfce_panel_exported_service_method_info_display_items_dialog_IN_ARG_active =
{
  {
    -1,
    (gchar *) "active",
    (gchar *) "u",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _xfce_panel_exported_service_method_info_display_items_dialog_IN_ARG_pointers[] =
{
  &_xfce_panel_exported_service_method_info_display_items_dialog_IN_ARG_active.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _xfce_panel_exported_service_method_info_display_items_dialog =
{
  {
    -1,
    (gchar *) "DisplayItemsDialog",
    (GDBusArgInfo **) &_xfce_panel_exported_service_method_info_display_items_dialog_IN_ARG_pointers,
    NULL,
    NULL
  },
  "handle-display-items-dialog",
  FALSE
};

static const _ExtendedGDBusMethodInfo _xfce_panel_exported_service_method_info_save =
{
  {
    -1,
    (gchar *) "Save",
    NULL,
    NULL,
    NULL
  },
  "handle-save",
  FALSE
};

static const _ExtendedGDBusArgInfo _xfce_panel_exported_service_method_info_add_new_item_IN_ARG_plugin_name =
{
  {
    -1,
    (gchar *) "plugin_name",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo _xfce_panel_exported_service_method_info_add_new_item_IN_ARG_arguments =
{
  {
    -1,
    (gchar *) "arguments",
    (gchar *) "as",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _xfce_panel_exported_service_method_info_add_new_item_IN_ARG_pointers[] =
{
  &_xfce_panel_exported_service_method_info_add_new_item_IN_ARG_plugin_name.parent_struct,
  &_xfce_panel_exported_service_method_info_add_new_item_IN_ARG_arguments.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _xfce_panel_exported_service_method_info_add_new_item =
{
  {
    -1,
    (gchar *) "AddNewItem",
    (GDBusArgInfo **) &_xfce_panel_exported_service_method_info_add_new_item_IN_ARG_pointers,
    NULL,
    NULL
  },
  "handle-add-new-item",
  FALSE
};

static const _ExtendedGDBusArgInfo _xfce_panel_exported_service_method_info_plugin_event_IN_ARG_plugin_name =
{
  {
    -1,
    (gchar *) "plugin_name",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo _xfce_panel_exported_service_method_info_plugin_event_IN_ARG_name =
{
  {
    -1,
    (gchar *) "name",
    (gchar *) "s",
    NULL
  },
  FALSE
};

static const _ExtendedGDBusArgInfo _xfce_panel_exported_service_method_info_plugin_event_IN_ARG_value =
{
  {
    -1,
    (gchar *) "value",
    (gchar *) "v",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _xfce_panel_exported_service_method_info_plugin_event_IN_ARG_pointers[] =
{
  &_xfce_panel_exported_service_method_info_plugin_event_IN_ARG_plugin_name.parent_struct,
  &_xfce_panel_exported_service_method_info_plugin_event_IN_ARG_name.parent_struct,
  &_xfce_panel_exported_service_method_info_plugin_event_IN_ARG_value.parent_struct,
  NULL
};

static const _ExtendedGDBusArgInfo _xfce_panel_exported_service_method_info_plugin_event_OUT_ARG_succeed =
{
  {
    -1,
    (gchar *) "succeed",
    (gchar *) "b",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _xfce_panel_exported_service_method_info_plugin_event_OUT_ARG_pointers[] =
{
  &_xfce_panel_exported_service_method_info_plugin_event_OUT_ARG_succeed.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _xfce_panel_exported_service_method_info_plugin_event =
{
  {
    -1,
    (gchar *) "PluginEvent",
    (GDBusArgInfo **) &_xfce_panel_exported_service_method_info_plugin_event_IN_ARG_pointers,
    (GDBusArgInfo **) &_xfce_panel_exported_service_method_info_plugin_event_OUT_ARG_pointers,
    NULL
  },
  "handle-plugin-event",
  FALSE
};

static const _ExtendedGDBusArgInfo _xfce_panel_exported_service_method_info_terminate_IN_ARG_restart =
{
  {
    -1,
    (gchar *) "restart",
    (gchar *) "b",
    NULL
  },
  FALSE
};

static const GDBusArgInfo * const _xfce_panel_exported_service_method_info_terminate_IN_ARG_pointers[] =
{
  &_xfce_panel_exported_service_method_info_terminate_IN_ARG_restart.parent_struct,
  NULL
};

static const _ExtendedGDBusMethodInfo _xfce_panel_exported_service_method_info_terminate =
{
  {
    -1,
    (gchar *) "Terminate",
    (GDBusArgInfo **) &_xfce_panel_exported_service_method_info_terminate_IN_ARG_pointers,
    NULL,
    NULL
  },
  "handle-terminate",
  FALSE
};

static const GDBusMethodInfo * const _xfce_panel_exported_service_method_info_pointers[] =
{
  &_xfce_panel_exported_service_method_info_display_preferences_dialog.parent_struct,
  &_xfce_panel_exported_service_method_info_display_items_dialog.parent_struct,
  &_xfce_panel_exported_service_method_info_save.parent_struct,
  &_xfce_panel_exported_service_method_info_add_new_item.parent_struct,
  &_xfce_panel_exported_service_method_info_plugin_event.parent_struct,
  &_xfce_panel_exported_service_method_info_terminate.parent_struct,
  NULL
};

static const _ExtendedGDBusInterfaceInfo _xfce_panel_exported_service_interface_info =
{
  {
    -1,
    (gchar *) "org.xfce.Panel",
    (GDBusMethodInfo **) &_xfce_panel_exported_service_method_info_pointers,
    NULL,
    NULL,
    NULL
  },
  "exported-service",
};


/**
 * xfce_panel_exported_service_interface_info:
 *
 * Gets a machine-readable description of the <link linkend="gdbus-interface-org-xfce-Panel.top_of_page">org.xfce.Panel</link> D-Bus interface.
 *
 * Returns: (transfer none): A #GDBusInterfaceInfo. Do not free.
 */
GDBusInterfaceInfo *
xfce_panel_exported_service_interface_info (void)
{
  return (GDBusInterfaceInfo *) &_xfce_panel_exported_service_interface_info.parent_struct;
}

/**
 * xfce_panel_exported_service_override_properties:
 * @klass: The class structure for a #GObject derived class.
 * @property_id_begin: The property id to assign to the first overridden property.
 *
 * Overrides all #GObject properties in the #XfcePanelExportedService interface for a concrete class.
 * The properties are overridden in the order they are defined.
 *
 * Returns: The last property id.
 */
guint
xfce_panel_exported_service_override_properties (GObjectClass *klass G_GNUC_UNUSED, guint property_id_begin)
{
  return property_id_begin - 1;
}


inline static void
xfce_panel_exported_service_method_marshal_display_preferences_dialog (
    GClosure     *closure,
    GValue       *return_value,
    unsigned int  n_param_values,
    const GValue *param_values,
    void         *invocation_hint,
    void         *marshal_data)
{
  _g_dbus_codegen_marshal_BOOLEAN__OBJECT_UINT_UINT (closure,
    return_value, n_param_values, param_values, invocation_hint, marshal_data);
}

inline static void
xfce_panel_exported_service_method_marshal_display_items_dialog (
    GClosure     *closure,
    GValue       *return_value,
    unsigned int  n_param_values,
    const GValue *param_values,
    void         *invocation_hint,
    void         *marshal_data)
{
  _g_dbus_codegen_marshal_BOOLEAN__OBJECT_UINT (closure,
    return_value, n_param_values, param_values, invocation_hint, marshal_data);
}

inline static void
xfce_panel_exported_service_method_marshal_save (
    GClosure     *closure,
    GValue       *return_value,
    unsigned int  n_param_values,
    const GValue *param_values,
    void         *invocation_hint,
    void         *marshal_data)
{
  _g_dbus_codegen_marshal_BOOLEAN__OBJECT (closure,
    return_value, n_param_values, param_values, invocation_hint, marshal_data);
}

inline static void
xfce_panel_exported_service_method_marshal_add_new_item (
    GClosure     *closure,
    GValue       *return_value,
    unsigned int  n_param_values,
    const GValue *param_values,
    void         *invocation_hint,
    void         *marshal_data)
{
  _g_dbus_codegen_marshal_BOOLEAN__OBJECT_STRING_BOXED (closure,
    return_value, n_param_values, param_values, invocation_hint, marshal_data);
}

inline static void
xfce_panel_exported_service_method_marshal_plugin_event (
    GClosure     *closure,
    GValue       *return_value,
    unsigned int  n_param_values,
    const GValue *param_values,
    void         *invocation_hint,
    void         *marshal_data)
{
  _g_dbus_codegen_marshal_BOOLEAN__OBJECT_STRING_STRING_VARIANT (closure,
    return_value, n_param_values, param_values, invocation_hint, marshal_data);
}

inline static void
xfce_panel_exported_service_method_marshal_terminate (
    GClosure     *closure,
    GValue       *return_value,
    unsigned int  n_param_values,
    const GValue *param_values,
    void         *invocation_hint,
    void         *marshal_data)
{
  _g_dbus_codegen_marshal_BOOLEAN__OBJECT_BOOLEAN (closure,
    return_value, n_param_values, param_values, invocation_hint, marshal_data);
}


/**
 * XfcePanelExportedService:
 *
 * Abstract interface type for the D-Bus interface <link linkend="gdbus-interface-org-xfce-Panel.top_of_page">org.xfce.Panel</link>.
 */

/**
 * XfcePanelExportedServiceIface:
 * @parent_iface: The parent interface.
 * @handle_add_new_item: Handler for the #XfcePanelExportedService::handle-add-new-item signal.
 * @handle_display_items_dialog: Handler for the #XfcePanelExportedService::handle-display-items-dialog signal.
 * @handle_display_preferences_dialog: Handler for the #XfcePanelExportedService::handle-display-preferences-dialog signal.
 * @handle_plugin_event: Handler for the #XfcePanelExportedService::handle-plugin-event signal.
 * @handle_save: Handler for the #XfcePanelExportedService::handle-save signal.
 * @handle_terminate: Handler for the #XfcePanelExportedService::handle-terminate signal.
 *
 * Virtual table for the D-Bus interface <link linkend="gdbus-interface-org-xfce-Panel.top_of_page">org.xfce.Panel</link>.
 */

typedef XfcePanelExportedServiceIface XfcePanelExportedServiceInterface;
G_DEFINE_INTERFACE (XfcePanelExportedService, xfce_panel_exported_service, G_TYPE_OBJECT)

static void
xfce_panel_exported_service_default_init (XfcePanelExportedServiceIface *iface)
{
  /* GObject signals for incoming D-Bus method calls: */
  /**
   * XfcePanelExportedService::handle-display-preferences-dialog:
   * @object: A #XfcePanelExportedService.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_active: Argument passed by remote caller.
   * @arg_socket_id: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-xfce-Panel.DisplayPreferencesDialog">DisplayPreferencesDialog()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call xfce_panel_exported_service_complete_display_preferences_dialog() or e.g. g_dbus_method_invocation_return_error() on it) and no other signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-display-preferences-dialog",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (XfcePanelExportedServiceIface, handle_display_preferences_dialog),
    g_signal_accumulator_true_handled,
    NULL,
      xfce_panel_exported_service_method_marshal_display_preferences_dialog,
    G_TYPE_BOOLEAN,
    3,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_UINT, G_TYPE_UINT);

  /**
   * XfcePanelExportedService::handle-display-items-dialog:
   * @object: A #XfcePanelExportedService.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_active: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-xfce-Panel.DisplayItemsDialog">DisplayItemsDialog()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call xfce_panel_exported_service_complete_display_items_dialog() or e.g. g_dbus_method_invocation_return_error() on it) and no other signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-display-items-dialog",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (XfcePanelExportedServiceIface, handle_display_items_dialog),
    g_signal_accumulator_true_handled,
    NULL,
      xfce_panel_exported_service_method_marshal_display_items_dialog,
    G_TYPE_BOOLEAN,
    2,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_UINT);

  /**
   * XfcePanelExportedService::handle-save:
   * @object: A #XfcePanelExportedService.
   * @invocation: A #GDBusMethodInvocation.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-xfce-Panel.Save">Save()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call xfce_panel_exported_service_complete_save() or e.g. g_dbus_method_invocation_return_error() on it) and no other signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-save",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (XfcePanelExportedServiceIface, handle_save),
    g_signal_accumulator_true_handled,
    NULL,
      xfce_panel_exported_service_method_marshal_save,
    G_TYPE_BOOLEAN,
    1,
    G_TYPE_DBUS_METHOD_INVOCATION);

  /**
   * XfcePanelExportedService::handle-add-new-item:
   * @object: A #XfcePanelExportedService.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_plugin_name: Argument passed by remote caller.
   * @arg_arguments: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-xfce-Panel.AddNewItem">AddNewItem()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call xfce_panel_exported_service_complete_add_new_item() or e.g. g_dbus_method_invocation_return_error() on it) and no other signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-add-new-item",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (XfcePanelExportedServiceIface, handle_add_new_item),
    g_signal_accumulator_true_handled,
    NULL,
      xfce_panel_exported_service_method_marshal_add_new_item,
    G_TYPE_BOOLEAN,
    3,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_STRING, G_TYPE_STRV);

  /**
   * XfcePanelExportedService::handle-plugin-event:
   * @object: A #XfcePanelExportedService.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_plugin_name: Argument passed by remote caller.
   * @arg_name: Argument passed by remote caller.
   * @arg_value: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-xfce-Panel.PluginEvent">PluginEvent()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call xfce_panel_exported_service_complete_plugin_event() or e.g. g_dbus_method_invocation_return_error() on it) and no other signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-plugin-event",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (XfcePanelExportedServiceIface, handle_plugin_event),
    g_signal_accumulator_true_handled,
    NULL,
      xfce_panel_exported_service_method_marshal_plugin_event,
    G_TYPE_BOOLEAN,
    4,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_VARIANT);

  /**
   * XfcePanelExportedService::handle-terminate:
   * @object: A #XfcePanelExportedService.
   * @invocation: A #GDBusMethodInvocation.
   * @arg_restart: Argument passed by remote caller.
   *
   * Signal emitted when a remote caller is invoking the <link linkend="gdbus-method-org-xfce-Panel.Terminate">Terminate()</link> D-Bus method.
   *
   * If a signal handler returns %TRUE, it means the signal handler will handle the invocation (e.g. take a reference to @invocation and eventually call xfce_panel_exported_service_complete_terminate() or e.g. g_dbus_method_invocation_return_error() on it) and no other signal handlers will run. If no signal handler handles the invocation, the %G_DBUS_ERROR_UNKNOWN_METHOD error is returned.
   *
   * Returns: %G_DBUS_METHOD_INVOCATION_HANDLED or %TRUE if the invocation was handled, %G_DBUS_METHOD_INVOCATION_UNHANDLED or %FALSE to let other signal handlers run.
   */
  g_signal_new ("handle-terminate",
    G_TYPE_FROM_INTERFACE (iface),
    G_SIGNAL_RUN_LAST,
    G_STRUCT_OFFSET (XfcePanelExportedServiceIface, handle_terminate),
    g_signal_accumulator_true_handled,
    NULL,
      xfce_panel_exported_service_method_marshal_terminate,
    G_TYPE_BOOLEAN,
    2,
    G_TYPE_DBUS_METHOD_INVOCATION, G_TYPE_BOOLEAN);

}

/**
 * xfce_panel_exported_service_call_display_preferences_dialog:
 * @proxy: A #XfcePanelExportedServiceProxy.
 * @arg_active: Argument to pass with the method invocation.
 * @arg_socket_id: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-xfce-Panel.DisplayPreferencesDialog">DisplayPreferencesDialog()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call xfce_panel_exported_service_call_display_preferences_dialog_finish() to get the result of the operation.
 *
 * See xfce_panel_exported_service_call_display_preferences_dialog_sync() for the synchronous, blocking version of this method.
 */
void
xfce_panel_exported_service_call_display_preferences_dialog (
    XfcePanelExportedService *proxy,
    guint arg_active,
    guint arg_socket_id,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "DisplayPreferencesDialog",
    g_variant_new ("(uu)",
                   arg_active,
                   arg_socket_id),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * xfce_panel_exported_service_call_display_preferences_dialog_finish:
 * @proxy: A #XfcePanelExportedServiceProxy.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to xfce_panel_exported_service_call_display_preferences_dialog().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with xfce_panel_exported_service_call_display_preferences_dialog().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
xfce_panel_exported_service_call_display_preferences_dialog_finish (
    XfcePanelExportedService *proxy,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * xfce_panel_exported_service_call_display_preferences_dialog_sync:
 * @proxy: A #XfcePanelExportedServiceProxy.
 * @arg_active: Argument to pass with the method invocation.
 * @arg_socket_id: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-xfce-Panel.DisplayPreferencesDialog">DisplayPreferencesDialog()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See xfce_panel_exported_service_call_display_preferences_dialog() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
xfce_panel_exported_service_call_display_preferences_dialog_sync (
    XfcePanelExportedService *proxy,
    guint arg_active,
    guint arg_socket_id,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "DisplayPreferencesDialog",
    g_variant_new ("(uu)",
                   arg_active,
                   arg_socket_id),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * xfce_panel_exported_service_call_display_items_dialog:
 * @proxy: A #XfcePanelExportedServiceProxy.
 * @arg_active: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-xfce-Panel.DisplayItemsDialog">DisplayItemsDialog()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call xfce_panel_exported_service_call_display_items_dialog_finish() to get the result of the operation.
 *
 * See xfce_panel_exported_service_call_display_items_dialog_sync() for the synchronous, blocking version of this method.
 */
void
xfce_panel_exported_service_call_display_items_dialog (
    XfcePanelExportedService *proxy,
    guint arg_active,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "DisplayItemsDialog",
    g_variant_new ("(u)",
                   arg_active),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * xfce_panel_exported_service_call_display_items_dialog_finish:
 * @proxy: A #XfcePanelExportedServiceProxy.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to xfce_panel_exported_service_call_display_items_dialog().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with xfce_panel_exported_service_call_display_items_dialog().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
xfce_panel_exported_service_call_display_items_dialog_finish (
    XfcePanelExportedService *proxy,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * xfce_panel_exported_service_call_display_items_dialog_sync:
 * @proxy: A #XfcePanelExportedServiceProxy.
 * @arg_active: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-xfce-Panel.DisplayItemsDialog">DisplayItemsDialog()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See xfce_panel_exported_service_call_display_items_dialog() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
xfce_panel_exported_service_call_display_items_dialog_sync (
    XfcePanelExportedService *proxy,
    guint arg_active,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "DisplayItemsDialog",
    g_variant_new ("(u)",
                   arg_active),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * xfce_panel_exported_service_call_save:
 * @proxy: A #XfcePanelExportedServiceProxy.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-xfce-Panel.Save">Save()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call xfce_panel_exported_service_call_save_finish() to get the result of the operation.
 *
 * See xfce_panel_exported_service_call_save_sync() for the synchronous, blocking version of this method.
 */
void
xfce_panel_exported_service_call_save (
    XfcePanelExportedService *proxy,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "Save",
    g_variant_new ("()"),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * xfce_panel_exported_service_call_save_finish:
 * @proxy: A #XfcePanelExportedServiceProxy.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to xfce_panel_exported_service_call_save().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with xfce_panel_exported_service_call_save().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
xfce_panel_exported_service_call_save_finish (
    XfcePanelExportedService *proxy,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * xfce_panel_exported_service_call_save_sync:
 * @proxy: A #XfcePanelExportedServiceProxy.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-xfce-Panel.Save">Save()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See xfce_panel_exported_service_call_save() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
xfce_panel_exported_service_call_save_sync (
    XfcePanelExportedService *proxy,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "Save",
    g_variant_new ("()"),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * xfce_panel_exported_service_call_add_new_item:
 * @proxy: A #XfcePanelExportedServiceProxy.
 * @arg_plugin_name: Argument to pass with the method invocation.
 * @arg_arguments: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-xfce-Panel.AddNewItem">AddNewItem()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call xfce_panel_exported_service_call_add_new_item_finish() to get the result of the operation.
 *
 * See xfce_panel_exported_service_call_add_new_item_sync() for the synchronous, blocking version of this method.
 */
void
xfce_panel_exported_service_call_add_new_item (
    XfcePanelExportedService *proxy,
    const gchar *arg_plugin_name,
    const gchar *const *arg_arguments,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "AddNewItem",
    g_variant_new ("(s^as)",
                   arg_plugin_name,
                   arg_arguments),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * xfce_panel_exported_service_call_add_new_item_finish:
 * @proxy: A #XfcePanelExportedServiceProxy.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to xfce_panel_exported_service_call_add_new_item().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with xfce_panel_exported_service_call_add_new_item().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
xfce_panel_exported_service_call_add_new_item_finish (
    XfcePanelExportedService *proxy,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * xfce_panel_exported_service_call_add_new_item_sync:
 * @proxy: A #XfcePanelExportedServiceProxy.
 * @arg_plugin_name: Argument to pass with the method invocation.
 * @arg_arguments: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-xfce-Panel.AddNewItem">AddNewItem()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See xfce_panel_exported_service_call_add_new_item() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
xfce_panel_exported_service_call_add_new_item_sync (
    XfcePanelExportedService *proxy,
    const gchar *arg_plugin_name,
    const gchar *const *arg_arguments,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "AddNewItem",
    g_variant_new ("(s^as)",
                   arg_plugin_name,
                   arg_arguments),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * xfce_panel_exported_service_call_plugin_event:
 * @proxy: A #XfcePanelExportedServiceProxy.
 * @arg_plugin_name: Argument to pass with the method invocation.
 * @arg_name: Argument to pass with the method invocation.
 * @arg_value: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-xfce-Panel.PluginEvent">PluginEvent()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call xfce_panel_exported_service_call_plugin_event_finish() to get the result of the operation.
 *
 * See xfce_panel_exported_service_call_plugin_event_sync() for the synchronous, blocking version of this method.
 */
void
xfce_panel_exported_service_call_plugin_event (
    XfcePanelExportedService *proxy,
    const gchar *arg_plugin_name,
    const gchar *arg_name,
    GVariant *arg_value,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "PluginEvent",
    g_variant_new ("(ss@v)",
                   arg_plugin_name,
                   arg_name,
                   arg_value),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * xfce_panel_exported_service_call_plugin_event_finish:
 * @proxy: A #XfcePanelExportedServiceProxy.
 * @out_succeed: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to xfce_panel_exported_service_call_plugin_event().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with xfce_panel_exported_service_call_plugin_event().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
xfce_panel_exported_service_call_plugin_event_finish (
    XfcePanelExportedService *proxy,
    gboolean *out_succeed,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(b)",
                 out_succeed);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * xfce_panel_exported_service_call_plugin_event_sync:
 * @proxy: A #XfcePanelExportedServiceProxy.
 * @arg_plugin_name: Argument to pass with the method invocation.
 * @arg_name: Argument to pass with the method invocation.
 * @arg_value: Argument to pass with the method invocation.
 * @out_succeed: (out) (optional): Return location for return parameter or %NULL to ignore.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-xfce-Panel.PluginEvent">PluginEvent()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See xfce_panel_exported_service_call_plugin_event() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
xfce_panel_exported_service_call_plugin_event_sync (
    XfcePanelExportedService *proxy,
    const gchar *arg_plugin_name,
    const gchar *arg_name,
    GVariant *arg_value,
    gboolean *out_succeed,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "PluginEvent",
    g_variant_new ("(ss@v)",
                   arg_plugin_name,
                   arg_name,
                   arg_value),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "(b)",
                 out_succeed);
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * xfce_panel_exported_service_call_terminate:
 * @proxy: A #XfcePanelExportedServiceProxy.
 * @arg_restart: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied or %NULL.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously invokes the <link linkend="gdbus-method-org-xfce-Panel.Terminate">Terminate()</link> D-Bus method on @proxy.
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call xfce_panel_exported_service_call_terminate_finish() to get the result of the operation.
 *
 * See xfce_panel_exported_service_call_terminate_sync() for the synchronous, blocking version of this method.
 */
void
xfce_panel_exported_service_call_terminate (
    XfcePanelExportedService *proxy,
    gboolean arg_restart,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data)
{
  g_dbus_proxy_call (G_DBUS_PROXY (proxy),
    "Terminate",
    g_variant_new ("(b)",
                   arg_restart),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    callback,
    user_data);
}

/**
 * xfce_panel_exported_service_call_terminate_finish:
 * @proxy: A #XfcePanelExportedServiceProxy.
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to xfce_panel_exported_service_call_terminate().
 * @error: Return location for error or %NULL.
 *
 * Finishes an operation started with xfce_panel_exported_service_call_terminate().
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
xfce_panel_exported_service_call_terminate_finish (
    XfcePanelExportedService *proxy,
    GAsyncResult *res,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_finish (G_DBUS_PROXY (proxy), res, error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * xfce_panel_exported_service_call_terminate_sync:
 * @proxy: A #XfcePanelExportedServiceProxy.
 * @arg_restart: Argument to pass with the method invocation.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL.
 *
 * Synchronously invokes the <link linkend="gdbus-method-org-xfce-Panel.Terminate">Terminate()</link> D-Bus method on @proxy. The calling thread is blocked until a reply is received.
 *
 * See xfce_panel_exported_service_call_terminate() for the asynchronous version of this method.
 *
 * Returns: (skip): %TRUE if the call succeeded, %FALSE if @error is set.
 */
gboolean
xfce_panel_exported_service_call_terminate_sync (
    XfcePanelExportedService *proxy,
    gboolean arg_restart,
    GCancellable *cancellable,
    GError **error)
{
  GVariant *_ret;
  _ret = g_dbus_proxy_call_sync (G_DBUS_PROXY (proxy),
    "Terminate",
    g_variant_new ("(b)",
                   arg_restart),
    G_DBUS_CALL_FLAGS_NONE,
    -1,
    cancellable,
    error);
  if (_ret == NULL)
    goto _out;
  g_variant_get (_ret,
                 "()");
  g_variant_unref (_ret);
_out:
  return _ret != NULL;
}

/**
 * xfce_panel_exported_service_complete_display_preferences_dialog:
 * @object: A #XfcePanelExportedService.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-xfce-Panel.DisplayPreferencesDialog">DisplayPreferencesDialog()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
xfce_panel_exported_service_complete_display_preferences_dialog (
    XfcePanelExportedService *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("()"));
}

/**
 * xfce_panel_exported_service_complete_display_items_dialog:
 * @object: A #XfcePanelExportedService.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-xfce-Panel.DisplayItemsDialog">DisplayItemsDialog()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
xfce_panel_exported_service_complete_display_items_dialog (
    XfcePanelExportedService *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("()"));
}

/**
 * xfce_panel_exported_service_complete_save:
 * @object: A #XfcePanelExportedService.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-xfce-Panel.Save">Save()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
xfce_panel_exported_service_complete_save (
    XfcePanelExportedService *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("()"));
}

/**
 * xfce_panel_exported_service_complete_add_new_item:
 * @object: A #XfcePanelExportedService.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-xfce-Panel.AddNewItem">AddNewItem()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
xfce_panel_exported_service_complete_add_new_item (
    XfcePanelExportedService *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("()"));
}

/**
 * xfce_panel_exported_service_complete_plugin_event:
 * @object: A #XfcePanelExportedService.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 * @succeed: Parameter to return.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-xfce-Panel.PluginEvent">PluginEvent()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
xfce_panel_exported_service_complete_plugin_event (
    XfcePanelExportedService *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation,
    gboolean succeed)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("(b)",
                   succeed));
}

/**
 * xfce_panel_exported_service_complete_terminate:
 * @object: A #XfcePanelExportedService.
 * @invocation: (transfer full): A #GDBusMethodInvocation.
 *
 * Helper function used in service implementations to finish handling invocations of the <link linkend="gdbus-method-org-xfce-Panel.Terminate">Terminate()</link> D-Bus method. If you instead want to finish handling an invocation by returning an error, use g_dbus_method_invocation_return_error() or similar.
 *
 * This method will free @invocation, you cannot use it afterwards.
 */
void
xfce_panel_exported_service_complete_terminate (
    XfcePanelExportedService *object G_GNUC_UNUSED,
    GDBusMethodInvocation *invocation)
{
  g_dbus_method_invocation_return_value (invocation,
    g_variant_new ("()"));
}

/* ------------------------------------------------------------------------ */

/**
 * XfcePanelExportedServiceProxy:
 *
 * The #XfcePanelExportedServiceProxy structure contains only private data and should only be accessed using the provided API.
 */

/**
 * XfcePanelExportedServiceProxyClass:
 * @parent_class: The parent class.
 *
 * Class structure for #XfcePanelExportedServiceProxy.
 */

struct _XfcePanelExportedServiceProxyPrivate
{
  GData *qdata;
};

static void xfce_panel_exported_service_proxy_iface_init (XfcePanelExportedServiceIface *iface);

#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
G_DEFINE_TYPE_WITH_CODE (XfcePanelExportedServiceProxy, xfce_panel_exported_service_proxy, G_TYPE_DBUS_PROXY,
                         G_ADD_PRIVATE (XfcePanelExportedServiceProxy)
                         G_IMPLEMENT_INTERFACE (XFCE_PANEL_TYPE_EXPORTED_SERVICE, xfce_panel_exported_service_proxy_iface_init))

#else
G_DEFINE_TYPE_WITH_CODE (XfcePanelExportedServiceProxy, xfce_panel_exported_service_proxy, G_TYPE_DBUS_PROXY,
                         G_IMPLEMENT_INTERFACE (XFCE_PANEL_TYPE_EXPORTED_SERVICE, xfce_panel_exported_service_proxy_iface_init))

#endif
static void
xfce_panel_exported_service_proxy_finalize (GObject *object)
{
  XfcePanelExportedServiceProxy *proxy = XFCE_PANEL_EXPORTED_SERVICE_PROXY (object);
  g_datalist_clear (&proxy->priv->qdata);
  G_OBJECT_CLASS (xfce_panel_exported_service_proxy_parent_class)->finalize (object);
}

static void
xfce_panel_exported_service_proxy_get_property (GObject      *object G_GNUC_UNUSED,
  guint         prop_id G_GNUC_UNUSED,
  GValue       *value G_GNUC_UNUSED,
  GParamSpec   *pspec G_GNUC_UNUSED)
{
}

static void
xfce_panel_exported_service_proxy_set_property (GObject      *object G_GNUC_UNUSED,
  guint         prop_id G_GNUC_UNUSED,
  const GValue *value G_GNUC_UNUSED,
  GParamSpec   *pspec G_GNUC_UNUSED)
{
}

static void
xfce_panel_exported_service_proxy_g_signal (GDBusProxy *proxy,
  const gchar *sender_name G_GNUC_UNUSED,
  const gchar *signal_name,
  GVariant *parameters)
{
  _ExtendedGDBusSignalInfo *info;
  GVariantIter iter;
  GVariant *child;
  GValue *paramv;
  gsize num_params;
  gsize n;
  guint signal_id;
  info = (_ExtendedGDBusSignalInfo *) g_dbus_interface_info_lookup_signal ((GDBusInterfaceInfo *) &_xfce_panel_exported_service_interface_info.parent_struct, signal_name);
  if (info == NULL)
    return;
  num_params = g_variant_n_children (parameters);
  paramv = g_new0 (GValue, num_params + 1);
  g_value_init (&paramv[0], XFCE_PANEL_TYPE_EXPORTED_SERVICE);
  g_value_set_object (&paramv[0], proxy);
  g_variant_iter_init (&iter, parameters);
  n = 1;
  while ((child = g_variant_iter_next_value (&iter)) != NULL)
    {
      _ExtendedGDBusArgInfo *arg_info = (_ExtendedGDBusArgInfo *) info->parent_struct.args[n - 1];
      if (arg_info->use_gvariant)
        {
          g_value_init (&paramv[n], G_TYPE_VARIANT);
          g_value_set_variant (&paramv[n], child);
          n++;
        }
      else
        g_dbus_gvariant_to_gvalue (child, &paramv[n++]);
      g_variant_unref (child);
    }
  signal_id = g_signal_lookup (info->signal_name, XFCE_PANEL_TYPE_EXPORTED_SERVICE);
  g_signal_emitv (paramv, signal_id, 0, NULL);
  for (n = 0; n < num_params + 1; n++)
    g_value_unset (&paramv[n]);
  g_free (paramv);
}

static void
xfce_panel_exported_service_proxy_g_properties_changed (GDBusProxy *_proxy,
  GVariant *changed_properties,
  const gchar *const *invalidated_properties)
{
  XfcePanelExportedServiceProxy *proxy = XFCE_PANEL_EXPORTED_SERVICE_PROXY (_proxy);
  guint n;
  const gchar *key;
  GVariantIter *iter;
  _ExtendedGDBusPropertyInfo *info;
  g_variant_get (changed_properties, "a{sv}", &iter);
  while (g_variant_iter_next (iter, "{&sv}", &key, NULL))
    {
      info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_xfce_panel_exported_service_interface_info.parent_struct, key);
      g_datalist_remove_data (&proxy->priv->qdata, key);
      if (info != NULL)
        g_object_notify (G_OBJECT (proxy), info->hyphen_name);
    }
  g_variant_iter_free (iter);
  for (n = 0; invalidated_properties[n] != NULL; n++)
    {
      info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_xfce_panel_exported_service_interface_info.parent_struct, invalidated_properties[n]);
      g_datalist_remove_data (&proxy->priv->qdata, invalidated_properties[n]);
      if (info != NULL)
        g_object_notify (G_OBJECT (proxy), info->hyphen_name);
    }
}

static void
xfce_panel_exported_service_proxy_init (XfcePanelExportedServiceProxy *proxy)
{
#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
  proxy->priv = xfce_panel_exported_service_proxy_get_instance_private (proxy);
#else
  proxy->priv = G_TYPE_INSTANCE_GET_PRIVATE (proxy, XFCE_PANEL_TYPE_EXPORTED_SERVICE_PROXY, XfcePanelExportedServiceProxyPrivate);
#endif

  g_dbus_proxy_set_interface_info (G_DBUS_PROXY (proxy), xfce_panel_exported_service_interface_info ());
}

static void
xfce_panel_exported_service_proxy_class_init (XfcePanelExportedServiceProxyClass *klass)
{
  GObjectClass *gobject_class;
  GDBusProxyClass *proxy_class;

  gobject_class = G_OBJECT_CLASS (klass);
  gobject_class->finalize     = xfce_panel_exported_service_proxy_finalize;
  gobject_class->get_property = xfce_panel_exported_service_proxy_get_property;
  gobject_class->set_property = xfce_panel_exported_service_proxy_set_property;

  proxy_class = G_DBUS_PROXY_CLASS (klass);
  proxy_class->g_signal = xfce_panel_exported_service_proxy_g_signal;
  proxy_class->g_properties_changed = xfce_panel_exported_service_proxy_g_properties_changed;

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_38
  g_type_class_add_private (klass, sizeof (XfcePanelExportedServiceProxyPrivate));
#endif
}

static void
xfce_panel_exported_service_proxy_iface_init (XfcePanelExportedServiceIface *iface G_GNUC_UNUSED)
{
}

/**
 * xfce_panel_exported_service_proxy_new:
 * @connection: A #GDBusConnection.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: (nullable): A bus name (well-known or unique) or %NULL if @connection is not a message bus connection.
 * @object_path: An object path.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: User data to pass to @callback.
 *
 * Asynchronously creates a proxy for the D-Bus interface <link linkend="gdbus-interface-org-xfce-Panel.top_of_page">org.xfce.Panel</link>. See g_dbus_proxy_new() for more details.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call xfce_panel_exported_service_proxy_new_finish() to get the result of the operation.
 *
 * See xfce_panel_exported_service_proxy_new_sync() for the synchronous, blocking version of this constructor.
 */
void
xfce_panel_exported_service_proxy_new (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data)
{
  g_async_initable_new_async (XFCE_PANEL_TYPE_EXPORTED_SERVICE_PROXY, G_PRIORITY_DEFAULT, cancellable, callback, user_data, "g-flags", flags, "g-name", name, "g-connection", connection, "g-object-path", object_path, "g-interface-name", "org.xfce.Panel", NULL);
}

/**
 * xfce_panel_exported_service_proxy_new_finish:
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to xfce_panel_exported_service_proxy_new().
 * @error: Return location for error or %NULL
 *
 * Finishes an operation started with xfce_panel_exported_service_proxy_new().
 *
 * Returns: (transfer full) (type XfcePanelExportedServiceProxy): The constructed proxy object or %NULL if @error is set.
 */
XfcePanelExportedService *
xfce_panel_exported_service_proxy_new_finish (
    GAsyncResult        *res,
    GError             **error)
{
  GObject *ret;
  GObject *source_object;
  source_object = g_async_result_get_source_object (res);
  ret = g_async_initable_new_finish (G_ASYNC_INITABLE (source_object), res, error);
  g_object_unref (source_object);
  if (ret != NULL)
    return XFCE_PANEL_EXPORTED_SERVICE (ret);
  else
    return NULL;
}

/**
 * xfce_panel_exported_service_proxy_new_sync:
 * @connection: A #GDBusConnection.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: (nullable): A bus name (well-known or unique) or %NULL if @connection is not a message bus connection.
 * @object_path: An object path.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL
 *
 * Synchronously creates a proxy for the D-Bus interface <link linkend="gdbus-interface-org-xfce-Panel.top_of_page">org.xfce.Panel</link>. See g_dbus_proxy_new_sync() for more details.
 *
 * The calling thread is blocked until a reply is received.
 *
 * See xfce_panel_exported_service_proxy_new() for the asynchronous version of this constructor.
 *
 * Returns: (transfer full) (type XfcePanelExportedServiceProxy): The constructed proxy object or %NULL if @error is set.
 */
XfcePanelExportedService *
xfce_panel_exported_service_proxy_new_sync (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error)
{
  GInitable *ret;
  ret = g_initable_new (XFCE_PANEL_TYPE_EXPORTED_SERVICE_PROXY, cancellable, error, "g-flags", flags, "g-name", name, "g-connection", connection, "g-object-path", object_path, "g-interface-name", "org.xfce.Panel", NULL);
  if (ret != NULL)
    return XFCE_PANEL_EXPORTED_SERVICE (ret);
  else
    return NULL;
}


/**
 * xfce_panel_exported_service_proxy_new_for_bus:
 * @bus_type: A #GBusType.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: A bus name (well-known or unique).
 * @object_path: An object path.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @callback: A #GAsyncReadyCallback to call when the request is satisfied.
 * @user_data: User data to pass to @callback.
 *
 * Like xfce_panel_exported_service_proxy_new() but takes a #GBusType instead of a #GDBusConnection.
 *
 * When the operation is finished, @callback will be invoked in the thread-default main loop of the thread you are calling this method from (see g_main_context_push_thread_default()).
 * You can then call xfce_panel_exported_service_proxy_new_for_bus_finish() to get the result of the operation.
 *
 * See xfce_panel_exported_service_proxy_new_for_bus_sync() for the synchronous, blocking version of this constructor.
 */
void
xfce_panel_exported_service_proxy_new_for_bus (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data)
{
  g_async_initable_new_async (XFCE_PANEL_TYPE_EXPORTED_SERVICE_PROXY, G_PRIORITY_DEFAULT, cancellable, callback, user_data, "g-flags", flags, "g-name", name, "g-bus-type", bus_type, "g-object-path", object_path, "g-interface-name", "org.xfce.Panel", NULL);
}

/**
 * xfce_panel_exported_service_proxy_new_for_bus_finish:
 * @res: The #GAsyncResult obtained from the #GAsyncReadyCallback passed to xfce_panel_exported_service_proxy_new_for_bus().
 * @error: Return location for error or %NULL
 *
 * Finishes an operation started with xfce_panel_exported_service_proxy_new_for_bus().
 *
 * Returns: (transfer full) (type XfcePanelExportedServiceProxy): The constructed proxy object or %NULL if @error is set.
 */
XfcePanelExportedService *
xfce_panel_exported_service_proxy_new_for_bus_finish (
    GAsyncResult        *res,
    GError             **error)
{
  GObject *ret;
  GObject *source_object;
  source_object = g_async_result_get_source_object (res);
  ret = g_async_initable_new_finish (G_ASYNC_INITABLE (source_object), res, error);
  g_object_unref (source_object);
  if (ret != NULL)
    return XFCE_PANEL_EXPORTED_SERVICE (ret);
  else
    return NULL;
}

/**
 * xfce_panel_exported_service_proxy_new_for_bus_sync:
 * @bus_type: A #GBusType.
 * @flags: Flags from the #GDBusProxyFlags enumeration.
 * @name: A bus name (well-known or unique).
 * @object_path: An object path.
 * @cancellable: (nullable): A #GCancellable or %NULL.
 * @error: Return location for error or %NULL
 *
 * Like xfce_panel_exported_service_proxy_new_sync() but takes a #GBusType instead of a #GDBusConnection.
 *
 * The calling thread is blocked until a reply is received.
 *
 * See xfce_panel_exported_service_proxy_new_for_bus() for the asynchronous version of this constructor.
 *
 * Returns: (transfer full) (type XfcePanelExportedServiceProxy): The constructed proxy object or %NULL if @error is set.
 */
XfcePanelExportedService *
xfce_panel_exported_service_proxy_new_for_bus_sync (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error)
{
  GInitable *ret;
  ret = g_initable_new (XFCE_PANEL_TYPE_EXPORTED_SERVICE_PROXY, cancellable, error, "g-flags", flags, "g-name", name, "g-bus-type", bus_type, "g-object-path", object_path, "g-interface-name", "org.xfce.Panel", NULL);
  if (ret != NULL)
    return XFCE_PANEL_EXPORTED_SERVICE (ret);
  else
    return NULL;
}


/* ------------------------------------------------------------------------ */

/**
 * XfcePanelExportedServiceSkeleton:
 *
 * The #XfcePanelExportedServiceSkeleton structure contains only private data and should only be accessed using the provided API.
 */

/**
 * XfcePanelExportedServiceSkeletonClass:
 * @parent_class: The parent class.
 *
 * Class structure for #XfcePanelExportedServiceSkeleton.
 */

struct _XfcePanelExportedServiceSkeletonPrivate
{
  GValue *properties;
  GList *changed_properties;
  GSource *changed_properties_idle_source;
  GMainContext *context;
  GMutex lock;
};

static void
_xfce_panel_exported_service_skeleton_handle_method_call (
  GDBusConnection *connection G_GNUC_UNUSED,
  const gchar *sender G_GNUC_UNUSED,
  const gchar *object_path G_GNUC_UNUSED,
  const gchar *interface_name,
  const gchar *method_name,
  GVariant *parameters,
  GDBusMethodInvocation *invocation,
  gpointer user_data)
{
  XfcePanelExportedServiceSkeleton *skeleton = XFCE_PANEL_EXPORTED_SERVICE_SKELETON (user_data);
  _ExtendedGDBusMethodInfo *info;
  GVariantIter iter;
  GVariant *child;
  GValue *paramv;
  gsize num_params;
  guint num_extra;
  gsize n;
  guint signal_id;
  GValue return_value = G_VALUE_INIT;
  info = (_ExtendedGDBusMethodInfo *) g_dbus_method_invocation_get_method_info (invocation);
  g_assert (info != NULL);
  num_params = g_variant_n_children (parameters);
  num_extra = info->pass_fdlist ? 3 : 2;  paramv = g_new0 (GValue, num_params + num_extra);
  n = 0;
  g_value_init (&paramv[n], XFCE_PANEL_TYPE_EXPORTED_SERVICE);
  g_value_set_object (&paramv[n++], skeleton);
  g_value_init (&paramv[n], G_TYPE_DBUS_METHOD_INVOCATION);
  g_value_set_object (&paramv[n++], invocation);
  if (info->pass_fdlist)
    {
#ifdef G_OS_UNIX
      g_value_init (&paramv[n], G_TYPE_UNIX_FD_LIST);
      g_value_set_object (&paramv[n++], g_dbus_message_get_unix_fd_list (g_dbus_method_invocation_get_message (invocation)));
#else
      g_assert_not_reached ();
#endif
    }
  g_variant_iter_init (&iter, parameters);
  while ((child = g_variant_iter_next_value (&iter)) != NULL)
    {
      _ExtendedGDBusArgInfo *arg_info = (_ExtendedGDBusArgInfo *) info->parent_struct.in_args[n - num_extra];
      if (arg_info->use_gvariant)
        {
          g_value_init (&paramv[n], G_TYPE_VARIANT);
          g_value_set_variant (&paramv[n], child);
          n++;
        }
      else
        g_dbus_gvariant_to_gvalue (child, &paramv[n++]);
      g_variant_unref (child);
    }
  signal_id = g_signal_lookup (info->signal_name, XFCE_PANEL_TYPE_EXPORTED_SERVICE);
  g_value_init (&return_value, G_TYPE_BOOLEAN);
  g_signal_emitv (paramv, signal_id, 0, &return_value);
  if (!g_value_get_boolean (&return_value))
    g_dbus_method_invocation_return_error (invocation, G_DBUS_ERROR, G_DBUS_ERROR_UNKNOWN_METHOD, "Method %s is not implemented on interface %s", method_name, interface_name);
  g_value_unset (&return_value);
  for (n = 0; n < num_params + num_extra; n++)
    g_value_unset (&paramv[n]);
  g_free (paramv);
}

static GVariant *
_xfce_panel_exported_service_skeleton_handle_get_property (
  GDBusConnection *connection G_GNUC_UNUSED,
  const gchar *sender G_GNUC_UNUSED,
  const gchar *object_path G_GNUC_UNUSED,
  const gchar *interface_name G_GNUC_UNUSED,
  const gchar *property_name,
  GError **error,
  gpointer user_data)
{
  XfcePanelExportedServiceSkeleton *skeleton = XFCE_PANEL_EXPORTED_SERVICE_SKELETON (user_data);
  GValue value = G_VALUE_INIT;
  GParamSpec *pspec;
  _ExtendedGDBusPropertyInfo *info;
  GVariant *ret;
  ret = NULL;
  info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_xfce_panel_exported_service_interface_info.parent_struct, property_name);
  g_assert (info != NULL);
  pspec = g_object_class_find_property (G_OBJECT_GET_CLASS (skeleton), info->hyphen_name);
  if (pspec == NULL)
    {
      g_set_error (error, G_DBUS_ERROR, G_DBUS_ERROR_INVALID_ARGS, "No property with name %s", property_name);
    }
  else
    {
      g_value_init (&value, pspec->value_type);
      g_object_get_property (G_OBJECT (skeleton), info->hyphen_name, &value);
      ret = g_dbus_gvalue_to_gvariant (&value, G_VARIANT_TYPE (info->parent_struct.signature));
      g_value_unset (&value);
    }
  return ret;
}

static gboolean
_xfce_panel_exported_service_skeleton_handle_set_property (
  GDBusConnection *connection G_GNUC_UNUSED,
  const gchar *sender G_GNUC_UNUSED,
  const gchar *object_path G_GNUC_UNUSED,
  const gchar *interface_name G_GNUC_UNUSED,
  const gchar *property_name,
  GVariant *variant,
  GError **error,
  gpointer user_data)
{
  XfcePanelExportedServiceSkeleton *skeleton = XFCE_PANEL_EXPORTED_SERVICE_SKELETON (user_data);
  GValue value = G_VALUE_INIT;
  GParamSpec *pspec;
  _ExtendedGDBusPropertyInfo *info;
  gboolean ret;
  ret = FALSE;
  info = (_ExtendedGDBusPropertyInfo *) g_dbus_interface_info_lookup_property ((GDBusInterfaceInfo *) &_xfce_panel_exported_service_interface_info.parent_struct, property_name);
  g_assert (info != NULL);
  pspec = g_object_class_find_property (G_OBJECT_GET_CLASS (skeleton), info->hyphen_name);
  if (pspec == NULL)
    {
      g_set_error (error, G_DBUS_ERROR, G_DBUS_ERROR_INVALID_ARGS, "No property with name %s", property_name);
    }
  else
    {
      if (info->use_gvariant)
        g_value_set_variant (&value, variant);
      else
        g_dbus_gvariant_to_gvalue (variant, &value);
      g_object_set_property (G_OBJECT (skeleton), info->hyphen_name, &value);
      g_value_unset (&value);
      ret = TRUE;
    }
  return ret;
}

static const GDBusInterfaceVTable _xfce_panel_exported_service_skeleton_vtable =
{
  _xfce_panel_exported_service_skeleton_handle_method_call,
  _xfce_panel_exported_service_skeleton_handle_get_property,
  _xfce_panel_exported_service_skeleton_handle_set_property,
  {NULL}
};

static GDBusInterfaceInfo *
xfce_panel_exported_service_skeleton_dbus_interface_get_info (GDBusInterfaceSkeleton *skeleton G_GNUC_UNUSED)
{
  return xfce_panel_exported_service_interface_info ();
}

static GDBusInterfaceVTable *
xfce_panel_exported_service_skeleton_dbus_interface_get_vtable (GDBusInterfaceSkeleton *skeleton G_GNUC_UNUSED)
{
  return (GDBusInterfaceVTable *) &_xfce_panel_exported_service_skeleton_vtable;
}

static GVariant *
xfce_panel_exported_service_skeleton_dbus_interface_get_properties (GDBusInterfaceSkeleton *_skeleton)
{
  XfcePanelExportedServiceSkeleton *skeleton = XFCE_PANEL_EXPORTED_SERVICE_SKELETON (_skeleton);

  GVariantBuilder builder;
  guint n;
#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_84
  g_variant_builder_init_static (&builder, G_VARIANT_TYPE ("a{sv}"));
#else
  g_variant_builder_init(&builder, G_VARIANT_TYPE ("a{sv}"));
#endif
  if (_xfce_panel_exported_service_interface_info.parent_struct.properties == NULL)
    goto out;
  for (n = 0; _xfce_panel_exported_service_interface_info.parent_struct.properties[n] != NULL; n++)
    {
      GDBusPropertyInfo *info = _xfce_panel_exported_service_interface_info.parent_struct.properties[n];
      if (info->flags & G_DBUS_PROPERTY_INFO_FLAGS_READABLE)
        {
          GVariant *value;
          value = _xfce_panel_exported_service_skeleton_handle_get_property (g_dbus_interface_skeleton_get_connection (G_DBUS_INTERFACE_SKELETON (skeleton)), NULL, g_dbus_interface_skeleton_get_object_path (G_DBUS_INTERFACE_SKELETON (skeleton)), "org.xfce.Panel", info->name, NULL, skeleton);
          if (value != NULL)
            {
              g_variant_take_ref (value);
              g_variant_builder_add (&builder, "{sv}", info->name, value);
              g_variant_unref (value);
            }
        }
    }
out:
  return g_variant_builder_end (&builder);
}

static void
xfce_panel_exported_service_skeleton_dbus_interface_flush (GDBusInterfaceSkeleton *_skeleton G_GNUC_UNUSED)
{
}

static void xfce_panel_exported_service_skeleton_iface_init (XfcePanelExportedServiceIface *iface);
#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
G_DEFINE_TYPE_WITH_CODE (XfcePanelExportedServiceSkeleton, xfce_panel_exported_service_skeleton, G_TYPE_DBUS_INTERFACE_SKELETON,
                         G_ADD_PRIVATE (XfcePanelExportedServiceSkeleton)
                         G_IMPLEMENT_INTERFACE (XFCE_PANEL_TYPE_EXPORTED_SERVICE, xfce_panel_exported_service_skeleton_iface_init))

#else
G_DEFINE_TYPE_WITH_CODE (XfcePanelExportedServiceSkeleton, xfce_panel_exported_service_skeleton, G_TYPE_DBUS_INTERFACE_SKELETON,
                         G_IMPLEMENT_INTERFACE (XFCE_PANEL_TYPE_EXPORTED_SERVICE, xfce_panel_exported_service_skeleton_iface_init))

#endif
static void
xfce_panel_exported_service_skeleton_finalize (GObject *object)
{
  XfcePanelExportedServiceSkeleton *skeleton = XFCE_PANEL_EXPORTED_SERVICE_SKELETON (object);
  g_list_free_full (skeleton->priv->changed_properties, (GDestroyNotify) _changed_property_free);
  if (skeleton->priv->changed_properties_idle_source != NULL)
    g_source_destroy (skeleton->priv->changed_properties_idle_source);
  g_main_context_unref (skeleton->priv->context);
  g_mutex_clear (&skeleton->priv->lock);
  G_OBJECT_CLASS (xfce_panel_exported_service_skeleton_parent_class)->finalize (object);
}

static void
xfce_panel_exported_service_skeleton_init (XfcePanelExportedServiceSkeleton *skeleton)
{
#if GLIB_VERSION_MAX_ALLOWED >= GLIB_VERSION_2_38
  skeleton->priv = xfce_panel_exported_service_skeleton_get_instance_private (skeleton);
#else
  skeleton->priv = G_TYPE_INSTANCE_GET_PRIVATE (skeleton, XFCE_PANEL_TYPE_EXPORTED_SERVICE_SKELETON, XfcePanelExportedServiceSkeletonPrivate);
#endif

  g_mutex_init (&skeleton->priv->lock);
  skeleton->priv->context = g_main_context_ref_thread_default ();
}

static void
xfce_panel_exported_service_skeleton_class_init (XfcePanelExportedServiceSkeletonClass *klass)
{
  GObjectClass *gobject_class;
  GDBusInterfaceSkeletonClass *skeleton_class;

  gobject_class = G_OBJECT_CLASS (klass);
  gobject_class->finalize = xfce_panel_exported_service_skeleton_finalize;

  skeleton_class = G_DBUS_INTERFACE_SKELETON_CLASS (klass);
  skeleton_class->get_info = xfce_panel_exported_service_skeleton_dbus_interface_get_info;
  skeleton_class->get_properties = xfce_panel_exported_service_skeleton_dbus_interface_get_properties;
  skeleton_class->flush = xfce_panel_exported_service_skeleton_dbus_interface_flush;
  skeleton_class->get_vtable = xfce_panel_exported_service_skeleton_dbus_interface_get_vtable;

#if GLIB_VERSION_MAX_ALLOWED < GLIB_VERSION_2_38
  g_type_class_add_private (klass, sizeof (XfcePanelExportedServiceSkeletonPrivate));
#endif
}

static void
xfce_panel_exported_service_skeleton_iface_init (XfcePanelExportedServiceIface *iface G_GNUC_UNUSED)
{
}

/**
 * xfce_panel_exported_service_skeleton_new:
 *
 * Creates a skeleton object for the D-Bus interface <link linkend="gdbus-interface-org-xfce-Panel.top_of_page">org.xfce.Panel</link>.
 *
 * Returns: (transfer full) (type XfcePanelExportedServiceSkeleton): The skeleton object.
 */
XfcePanelExportedService *
xfce_panel_exported_service_skeleton_new (void)
{
  return XFCE_PANEL_EXPORTED_SERVICE (g_object_new (XFCE_PANEL_TYPE_EXPORTED_SERVICE_SKELETON, NULL));
}

